from time import sleep
import sys
import Adafruit_DHT
from AWSIoTPythonSDK.MQTTLib import AWSIoTMQTTClient
from time import sleep
import threading
from threading import Thread
import json
from rpi_lcd import LCD
import RPi.GPIO as GPIO
import MFRC522
import signal

host = ""
rootCAPath = ""
certificatePath = ""
privateKeyPath = ""

my_rpi = AWSIoTMQTTClient("laboratory2")
my_rpi.configureEndpoint(host, 8883)
my_rpi.configureCredentials(rootCAPath, privateKeyPath, certificatePath)

my_rpi.configureOfflinePublishQueueing(-1)  # Infinite offline Publish queueing
my_rpi.configureDrainingFrequency(2)  # Draining: 2 Hz
my_rpi.configureConnectDisconnectTimeout(60)  # 10 sec
my_rpi.configureMQTTOperationTimeout(5)  # 5 sec

my_rpi.connect()

verify = 0
def customCallback(client, userdata, message):
	global verify
	lcd.clear()
	print("Received a new message: ")
	print(message.payload)
	print(type(json))
	jsonresponse = json.loads(message.payload)

	print("--------------\n\n")
	if jsonresponse["room"] == "2":
		if jsonresponse["user"] != "invalid":
			lcd.text('Welcome' ,1)
			lcd.text(jsonresponse["user"], 2)
			sleep(3)
			verify = 1
			lcd.clear()
			print(verify)
		else:
			lcd.text('Invalid Card' ,1)
			verify = 1
			sleep(3)
			lcd.clear()



# Capture SIGINT for cleanup when the script is aborted
def end_read(signal,frame):
	global continue_reading
	print "Ctrl+C captured, ending read."
	continue_reading = False
	GPIO.cleanup()

# Hook the SIGINT
signal.signal(signal.SIGINT, end_read)

lcd = LCD()
# Create an object of the class MFRC522
mfrc522 = MFRC522.MFRC522()

def runRFID():
	global verify
	while True:
		lcd.text('Tap RFID Card To Unlock' ,1)
	 	# Scan for cards
		(status,TagType) = mfrc522.MFRC522_Request(mfrc522.PICC_REQIDL)

	 	# If a card is found
		if status == mfrc522.MI_OK:

	 		# Get the UID of the card
			(status,uid) = mfrc522.MFRC522_Anticoll()
			print("New card detected! UID of card is {}".format(uid))
			data = {"room":"2","topic":"rfid","uid":uid}
			data = str(data)
			data = data.replace("\'","\"")
			data = data.replace("[", "\"[")
			data = data.replace("]", "]\"")
			data = unicode(data, "utf-8")
			print("Sending RFID values...")
			print(data)
			print("--------------\n\n")
			my_rpi.publish("lab/sensors", str(data),1)
			lcd.clear()
			lcd.text('Verifying...' ,1)
			while verify == 0:
				my_rpi.subscribe("rfid/verification", 1, customCallback)

			verify = 0

def pub_Temps_Lights():
	threading.Timer(5,pub_Temps_Lights).start()
	pin = 4
	humidity, temperature = Adafruit_DHT.read_retry(11,pin)
	temp = '{:.1f}'.format(temperature)
	humi = '{:.1f}'.format(humidity)

	data = {"room":"2","topic":"temps","temp":temp,"humi":humi}
	data = str(data)
	data = data.replace("\'","\"")
	data = unicode(data, "utf-8")
	print("Sending Tempurature values...")
	print(data)
	print("--------------\n\n")

	my_rpi.publish("lab/sensors", data,1)
